<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_RoomInfo StructType
 * @subpackage Structs
 */
class JP_RoomInfo extends AbstractStructBase
{
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The JRCode
     * @var string
     */
    public $JRCode;
    /**
     * Constructor method for JP_RoomInfo
     * @uses JP_RoomInfo::setName()
     * @uses JP_RoomInfo::setJRCode()
     * @param string $name
     * @param string $jRCode
     */
    public function __construct($name = null, $jRCode = null)
    {
        $this
            ->setName($name)
            ->setJRCode($jRCode);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JP_RoomInfo
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get JRCode value
     * @return string|null
     */
    public function getJRCode()
    {
        return $this->JRCode;
    }
    /**
     * Set JRCode value
     * @param string $jRCode
     * @return \StructType\JP_RoomInfo
     */
    public function setJRCode($jRCode = null)
    {
        // validation for constraint: string
        if (!is_null($jRCode) && !is_string($jRCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($jRCode)), __LINE__);
        }
        $this->JRCode = $jRCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JP_RoomInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
